VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Multiplayer Pong"
   ClientHeight    =   4125
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4845
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4125
   ScaleWidth      =   4845
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Join Game"
      Height          =   375
      Left            =   2520
      TabIndex        =   2
      Top             =   3720
      Width           =   2295
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Host Game"
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   3720
      Width           =   2535
   End
   Begin VB.PictureBox P1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   3660
      Left            =   0
      ScaleHeight     =   240
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   320
      TabIndex        =   0
      Top             =   0
      Width           =   4860
      Begin MSWinsockLib.Winsock SOCK 
         Left            =   2040
         Top             =   480
         _ExtentX        =   741
         _ExtentY        =   741
         _Version        =   393216
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function GetTickCount Lib "kernel32" () As Long

Dim MAXFRAMERATE As Long
Dim HOSTING As Boolean
Dim GameUp As Boolean
Dim Paused As Boolean
Dim Ballx As Long
Dim Bally As Long
Dim Ballxspeed As Long
Dim Ballyspeed As Long
Dim Paddle1y As Long
Dim Paddle2y As Long
Dim Plr As Long
Dim KeyUpDown As Boolean
Dim KeyDownDown As Boolean
Dim P1Score As Long
Dim P2Score As Long
Dim rFrameCount As Long
Dim BallResetting As Boolean
Dim Pinging As Boolean
Dim PingCount As Long
Dim PingS As Long
Dim PingE As Long
Dim Ping As Long


Private Sub Command1_Click()
SOCK.LocalPort = 4550
SOCK.Listen
DoEvents
Command1.Enabled = False
Command2.Enabled = False
HOSTING = True
Plr = 1
Form1.Caption = "Multiplayer Pong - Waiting for player to join"
End Sub

Private Sub Command2_Click()
SOCK.RemotePort = 4550
SOCK.RemoteHost = InputBox("Please enter the IP address", "Join Game")
DoEvents
SOCK.Connect
DoEvents
Plr = 2
Dim st As Long
st = GetTickCount
Do Until GetTickCount >= st + 2000
DoEvents
If SOCK.State = sckConnected Then
Command1.Enabled = False
Command2.Enabled = False
GameUp = True
'Reset_Ball 'not host, so why would we reset ball?
Game_Loop
End If
Loop
MsgBox "Unable to Connect"
SOCK.Close
End Sub



Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
If KeyCode = vbKeyUp Then
    KeyUpDown = True
ElseIf KeyCode = vbKeyDown Then
    KeyDownDown = True
End If
End Sub


Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
If KeyCode = vbKeyUp Then
    KeyUpDown = False
ElseIf KeyCode = vbKeyDown Then
    KeyDownDown = False
End If
End Sub

Private Sub Form_Load()
MAXFRAMERATE = 32
Paddle1y = 100
Paddle2y = 100
rFrameCount = 0
PingCount = 0
Ping = 0
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
End
End Sub

Private Sub SOCK_ConnectionRequest(ByVal requestID As Long)
'If SOCK.State <> sckClosed Then
'    SOCK.Close
'    DoEvents
'End If
SOCK.Close
DoEvents
SOCK.Accept (requestID)
DoEvents
Dim st As Long
st = GetTickCount
Do Until GetTickCount >= st + 2000
DoEvents
If SOCK.State = sckConnected Then
Form1.Caption = "Multiplayer Pong"
GameUp = True
Reset_Ball
Game_Loop
Exit Sub
End If
Loop
MsgBox "Error Recieving Connection"
End Sub

Function Random_Num(Lowerbound As Long, Upperbound As Long)
Randomize
Random_Num = Int((Upperbound - Lowerbound) * Rnd + Lowerbound)
End Function

Private Sub Game_Loop()
Dim st As Long
Dim et As Long
st = GetTickCount
Do While GameUp = True
If GetTickCount >= st + (1000 / MAXFRAMERATE) Then
    'do game shit here
    Game_Code
    DoEvents
    '^^
    st = GetTickCount
End If
DoEvents
Loop
End Sub

Private Sub Game_Code()

If Not Paused Then
Update_Positions 'do phys. etc. calcs if host and move paddle according to keystates
End If

Send_Data 'update everyone if host

Render
End Sub

Private Sub Update_Positions()
If HOSTING Then
    'paddles at 10 and 310
    
    If BallResetting Then
    rFrameCount = rFrameCount + 1
        If rFrameCount >= 96 Then
            BallResetting = False
            rFrameCount = 0
        End If
    End If
    
    If Not BallResetting Then
    Ballx = Ballx + Ballxspeed
    Bally = Bally + Ballyspeed
    End If
    
    'bounce ball off paddle(s)
    If Ballx >= 10 And Ballx <= 13 Then
        If Bally > Paddle1y And Bally < Paddle1y + 40 Then
            Ballxspeed = -Ballxspeed
            Ballyspeed = Ballyspeed + Random_Num(-2, 2)
        End If
    End If
    If Ballx <= 310 And Ballx >= 307 Then
        If Bally > Paddle2y And Bally < Paddle2y + 40 Then
            Ballxspeed = -Ballxspeed
            Ballyspeed = Ballyspeed + Random_Num(-2, 2)
        End If
    End If
    
    'score if ball passes paddle
    If Ballx > 310 Then
        P1Score = P1Score + 1
        Reset_Ball
    ElseIf Ballx < 10 Then
        P2Score = P2Score + 1
        Reset_Ball
    End If
    
    If Bally >= 240 Or Bally <= 0 Then
        Ballyspeed = -Ballyspeed
        If Ballxspeed = 0 Then
            Ballxspeed = Ballxspeed + Random_Num(-2, 2)
        End If
    End If
End If


If KeyDownDown = True Then
    If Plr = 1 Then
        If Paddle1y <= 200 Then
            Paddle1y = Paddle1y + 6
        End If
    ElseIf Plr = 2 Then
        If Paddle2y <= 200 Then
            Paddle2y = Paddle2y + 6
        End If
    End If
ElseIf KeyUpDown = True Then
    If Plr = 1 Then
        If Paddle1y >= 0 Then
            Paddle1y = Paddle1y - 6
        End If
    ElseIf Plr = 2 Then
        If Paddle2y >= 0 Then
            Paddle2y = Paddle2y - 6
        End If
    End If
End If
End Sub

Private Sub Send_Data()
If SOCK.State <> sckConnected Then
    If P1Score > P2Score Then
        MsgBox "Player left, the game is over. Player 1 is the winner."
    ElseIf P2Score > P1Score Then
        MsgBox "Player left, the game is over. Player 2 is the winner."
    ElseIf P1Score = P2Score Then
        MsgBox "Player left, the game is over. The game is a tie."
    End If
    End
End If
If HOSTING Then
    SOCK.SendData "py" & Paddle1y & "]" & "bx" & Ballx & "]" & "by" & Bally & "]" & "ps" & P1Score & "]" & "ts" & P2Score & "]" & "pn" & Ping & "]"
    If Not Pinging Then
        If GetTickCount > PingCount + 3000 Then
            Pinging = True
            PingS = GetTickCount
            SOCK.SendData "pp"
            DoEvents
        End If
    End If
Else
    SOCK.SendData "pt" & Paddle2y & "]"
End If

DoEvents
End Sub

Private Sub Render()
P1.Cls

'render scores before everything else so that paddles/ball go over em
P1.CurrentX = 40
P1.CurrentY = 10
P1.ForeColor = vbBlue
P1.Print P1Score
P1.CurrentX = 270
P1.CurrentY = 10
P1.ForeColor = vbRed
P1.Print P2Score
P1.ForeColor = vbBlack
P1.CurrentX = 5
P1.CurrentY = 220
P1.Print "Ping: " & Ping

'render other stuff
P1.ForeColor = vbBlue
P1.Line (10, Paddle1y)-(10, Paddle1y + 40)
P1.ForeColor = vbRed
P1.Line (310, Paddle2y)-(310, Paddle2y + 40)
P1.ForeColor = vbBlack
P1.Circle (Ballx, Bally), 3
P1.Refresh
End Sub

Private Sub Reset_Ball()
BallResetting = True

'reset ball
Ballx = 160
Bally = 120

'generate ball speeds
calcx:
Ballxspeed = Random_Num(-6, 6)

If Ballxspeed > -3 And Ballxspeed < 3 Then
GoTo calcx
End If

calcy:
Ballyspeed = Random_Num(-6, 6)

If Ballyspeed > -3 And Ballyspeed < 3 Then
GoTo calcy
End If

End Sub

Private Sub SOCK_DataArrival(ByVal bytesTotal As Long)
Dim dat As String
Dim i As Long
Dim ii As Long
Dim bracket As Long

SOCK.GetData dat

If HOSTING Then
For i = 1 To Len(dat)
    If Mid(dat, i, 2) = "pt" Then
        For ii = i + 2 To Len(dat)
            If Mid(dat, ii, 1) = "]" Then
                bracket = ii
                Paddle2y = CInt(Mid(dat, i + 2, ii - (i + 2)))
                Exit For
            End If
        Next ii
    ElseIf Mid(dat, i, 2) = "pr" Then
        PingE = GetTickCount
        Ping = PingE - PingS
        Pinging = False
        PingCount = GetTickCount
    'ElseIf Mid(dat, i, 2) = "ps" Then
    '    Paused = True
    End If
Next i
ElseIf Not HOSTING Then
For i = 1 To Len(dat)
    If Mid(dat, i, 2) = "py" Then
        For ii = i + 2 To Len(dat)
            If Mid(dat, ii, 1) = "]" Then
                bracket = ii
                Paddle1y = CInt(Mid(dat, i + 2, ii - (i + 2)))
                i = bracket
                Exit For
            End If
        Next ii
    ElseIf Mid(dat, i, 2) = "bx" Then
        For ii = i + 2 To Len(dat)
            If Mid(dat, ii, 1) = "]" Then
                bracket = ii
                Ballx = CInt(Mid(dat, i + 2, ii - (i + 2)))
                i = bracket
                Exit For
            End If
        Next ii
    ElseIf Mid(dat, i, 2) = "by" Then
        For ii = i + 2 To Len(dat)
            If Mid(dat, ii, 1) = "]" Then
                bracket = ii
                Bally = CInt(Mid(dat, i + 2, ii - (i + 2)))
                i = bracket
                Exit For
            End If
        Next ii
    ElseIf Mid(dat, i, 2) = "ps" Then
        For ii = i + 2 To Len(dat)
            If Mid(dat, ii, 1) = "]" Then
                bracket = ii
                P1Score = CInt(Mid(dat, i + 2, ii - (i + 2)))
                i = bracket
                Exit For
            End If
        Next ii
    ElseIf Mid(dat, i, 2) = "ts" Then
        For ii = i + 2 To Len(dat)
            If Mid(dat, ii, 1) = "]" Then
                bracket = ii
                P2Score = CInt(Mid(dat, i + 2, ii - (i + 2)))
                i = bracket
                Exit For
            End If
        Next ii
    ElseIf Mid(dat, i, 2) = "pn" Then
        For ii = i + 2 To Len(dat)
            If Mid(dat, ii, 1) = "]" Then
                bracket = ii
                Ping = CInt(Mid(dat, i + 2, ii - (i + 2)))
                i = bracket
                Exit For
            End If
        Next ii
    ElseIf Mid(dat, i, 2) = "pp" Then
        SOCK.SendData "pr"
        DoEvents
    End If
Next i
End If

DoEvents
End Sub
